package org.greenstone.gsdl3.gs3build.util;

import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.HashMap;
import java.util.ArrayList;

public class MultiMap
{	Map map;
	
	public MultiMap()
	{	this.map = new HashMap();
	}

	public boolean containsKey(Object key)
	{	return this.map.containsKey(key);
	}

	public void setOnly(Object key, Object value)
	{	List child = new ArrayList();
		child.add(value);
		this.map.put(key, child);
	}

	public void put(Object key, Object value)
	{	List children;

		children = (List) this.map.get(key);
		if (children == null)
		{	children = new ArrayList();
			this.map.put(key, children);
		}
		children.add(value);
	}

	public Object get(Object key)
	{	List list = this.getAll(key);
		if (list == null)
		{	return null;
		}
		return list.get(0);
	}

	public List getAll(Object key)
	{	return (List) this.map.get(key);
	}

	public void remove(Object key)
	{	this.map.remove(key);
	}

	public boolean remove(Object key, Object value)
	{	if (!this.map.containsKey(key))
		{ return false;
		}

		List children = (List) this.map.get(key);

		if (children != null)
		{	for (int i = 0; i < children.size(); i ++)
			{	if (children.get(i).equals(value))
				{	children.remove(i);
					return true;
				}
			}
		}
		return false;
	}

	public Set keySet()
	{	return this.map.keySet();
	}
}